﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.5
@EndOfDesignText@
'WebSocket class
Sub Class_Globals
	Private ws As WebSocket
	Private tabOrder, btnOrder, selezRiga, btnRemove, selDate, lblRowSelected, txtNota As JQueryElement
	Private TW As TextWriter
	Private ListaOrdine As List
	Private StampaOrdine As List
	
End Sub

Public Sub Initialize
	
End Sub

Private Sub WebSocket_Connected (WebSocket1 As WebSocket)
	ws = WebSocket1
	If ws.Session.GetAttribute("username") == Null Then
		WebUtils.RedirectTo(ws, "/index.html")
	End If
	If ws.Session.GetAttribute("ordine") == Null Then
		ListaOrdine.Initialize
		StampaOrdine.Initialize
	Else
		ListaOrdine = ws.Session.GetAttribute("ordine")
		StampaOrdine = ws.Session.GetAttribute("stampaOrdine")
	End If
'	btnOrder.RunMethod("hide", Null)
	btnRemove.RunMethod("hide", Null)
	ShowOrder(tabOrder)
	DateTime.DateFormat= "dd/MM/yyyy"
	selDate.SetVal(ConvertDateTomorrow(DateTime.Date(DateTime.Now)))
End Sub

Private Sub WebSocket_Disconnected
	
End Sub

Private Sub selDate_Change (Params As Map)
'	If selDate.GetVal.Value == "" Then
'		btnOrder.RunMethod("hide", Null)
'	Else
'		btnOrder.RunMethod("show", Null)
'	End If
End Sub

Private Sub btnOrder_Click (Params As Map)
If StampaOrdine.Size == 0 Then
		ws.RunFunction("swal",Array As Object(CreateMap( _
							"title": "ORDINE VUOTO", "text":"Il tuo ordine è vuoto! Vai alla pagina PRODOTTI per aggiungere degli elementi al tuo Carrello Ordini",  "icon": "info")))
	Else
		PrintOrder
End If
	ws.RunFunction("swal",Array As Object(CreateMap( _
							"title": "SEI SICURO?", "text":"Una volta inoltrato l'ordine non potrai più modificarlo!",  "icon": "warning", "buttons": True)))
	
End Sub

Private Sub btnRemove_Click (Params As Map)
	Dim f As Future = selezRiga.GetVal
	Dim i As Int = f.Value
	ListaOrdine.RemoveAt(i-1)
	StampaOrdine.RemoveAt(i-1)
	ws.Session.SetAttribute("ordine", ListaOrdine)
	ws.Session.SetAttribute("stampaOrdine", StampaOrdine)
	ShowOrder(tabOrder)
	btnRemove.RunMethod("hide", Null)
	lblRowSelected.RunMethod("hide", Null)
	
End Sub


Private Sub selezRiga_Change (Params As Map)
	Dim f As Future = selezRiga.GetVal
	Dim check As String = f.Value
	If check == "Nessun dato presente nella tabella" Then
		Log("ok")
		Else
			Log("non ok")
	End If
	
End Sub

Sub ShowOrder(jq As JQueryElement)
	Dim ItaLang As Map = CreateMap( _
	"sEmptyTable":     "Nessun dato presente nella tabella", _
	"sInfo":           "Vista da _START_ a _END_ di _TOTAL_ elementi", _
	"sInfoEmpty":      "Vista da 0 a 0 di 0 elementi", _
	"sInfoFiltered":   "(filtrati da _MAX_ elementi totali)", _
	"sInfoPostFix":    "", _
	"sInfoThousands":  ".", _
	"sLengthMenu":     "Visualizza _MENU_ elementi", _
	"sLoadingRecords": "Caricamento...", _
	"sProcessing":     "Elaborazione...", _
	"sSearch":         "Cerca:", _
	"sZeroRecords":    "La ricerca non ha portato alcun risultato.")
	
	jq.RunMethod("dataTable", Array As Object(CreateMap("aaData": ListaOrdine, "bDestroy": True, "bFilter": False, _
	"bPaginate": False, "sScrollY": "200px", "bSort": False, "bInfo": False, "scrollX": True, "scroller": True, "language": ItaLang)))
	
End Sub

Sub ConvertDate (Date As String) As String
	DateTime.DateFormat = "yyyy-MM-dd"
	Dim f As Long = DateTime.DateParse(Date)
	DateTime.DateFormat= "dd/MM/yyyy"
	Dim g As String = (DateTime.Date(f))
	Return g
	
End Sub

Sub ConvertDateTomorrow (s As String) As String
	DateTime.DateFormat= "dd/MM/yyyy"
	Dim f As Long = DateTime.DateParse(s)
	Dim domani As Long = DateTime.Add(f, 0,0,1)
	DateTime.DateFormat = "yyyy-MM-dd"
	Dim g As String = (DateTime.Date(domani))
	Return g
	
End Sub

Sub PrintOrder
	Dim dateFut As Future = selDate.GetVal
	Dim date As String = dateFut.Value
	If date <> "" Then
		Dim f As Future = txtNota.GetVal
		Dim nota As String = f.Value
		DateTime.DateFormat = "dd-MM-yyyy"
		DateTime.TimeFormat = "HHmmss"
		Dim d As String = DateTime.Date(DateTime.Now)
		Dim t As String = DateTime.Time(DateTime.Now)
		Dim piva As String = ws.Session.GetAttribute("piva")
		Dim username As String = ws.Session.GetAttribute("username")
		TW.Initialize(File.OpenOutput(File.DirApp, $"${piva}_${d}_${t}.txt"$, False))
		TW.writeline($"${username}"$)
		TW.WriteLine($"${ConvertDate(date)}"$)
		TW.WriteLine(nota.Trim)
		TW.WriteLine("*")
		TW.Writelist(StampaOrdine)
		TW.WriteLine("*")
		TW.Close
		ws.Session.RemoveAttribute("ordine")
		ListaOrdine.Initialize
		StampaOrdine.Initialize
		DateTime.DateFormat = "dd/MM/yyyy"
		DateTime.TimeFormat = "HH:mm:ss"
		Log(DateTime.Date(DateTime.Now) & "   " & DateTime.Time(DateTime.Now))
		Log($"Cliente P.IVA nr ${piva} ha inviato un ordine"$)
		btnOrder.RunMethod("hide", Null)
		ws.RunFunction("swal",Array As Object(CreateMap( _
							"title": "ORDINE INVIATO", "text":$"L'ordine è stato inoltrato correttamente, con data di consegna fissata per il ${ConvertDate(date)}"$,  "icon": "success")))
		ShowOrder(tabOrder)
	Else
		ws.RunFunction("swal",Array As Object(CreateMap( _
						"title": "SELEZIONARE UNA DATA", "text":"Data di consegna necessaria per inoltrare l'ordine",  "icon": "warning")))
	End If
	
End Sub